package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.feign.WmshboundFeign;
import com.steerinfo.dil.model.AmsshipCargoTransferResult;
import com.steerinfo.dil.mapper.AmsshipCargoTransferResultMapper;
import com.steerinfo.dil.service.IAmsshipCargoTransferResultService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * AmsshipCargoTransferResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-18 03:36
 * 类描述
 * 修订历史：
 * 日期：2021-08-18
 * 作者：generator
 * 参考：
 * 描述：AmsshipCargoTransferResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "amsshipCargoTransferResultService")
public class AmsshipCargoTransferResultServiceImpl implements IAmsshipCargoTransferResultService {

    @Autowired
    private AmsshipCargoTransferResultMapper amsshipCargoTransferResultMapper;
    @Autowired
    WmshboundFeign wmshboundFeign;

    @Override
    public List<Map<String, Object>> seletCargoTransfer(Map<String, Object> mapVal) {
        return amsshipCargoTransferResultMapper.seletCargoTransfer(mapVal);
    }

    @Override
    @Transactional
    public int insertSelective(AmsshipCargoTransferResult amsshipCargoTransferResult) {
        //货权转移编号
        BigDecimal cargoTransferResultId = amsshipCargoTransferResultMapper.selectCargoId();
        amsshipCargoTransferResult.setCargoTransferResultId(cargoTransferResultId);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
        String  date=sdf.format(new Date());
        // 修改港存库实时库存
        BigDecimal pierId = amsshipCargoTransferResult.getGroupId();
        BigDecimal portId = amsshipCargoTransferResultMapper.selectPortId(pierId);
        BigDecimal batchId = amsshipCargoTransferResult.getBatchId();
        BigDecimal resultNumberOfLoans = amsshipCargoTransferResult.getResultNumberOfLoans();
        Map<String,Object> map = new HashMap<>();
        map.put("portId",portId);
        map.put("batchId",batchId);
        map.put("resultMaterialNumber",resultNumberOfLoans);
        wmshboundFeign.addWarehousingResult(map);
        String resultNumber="ZY"+date+"00"+cargoTransferResultId;
        amsshipCargoTransferResult.setResultNumber(resultNumber);
        //  设置常规字段
        amsshipCargoTransferResult.setInsertTime(new Date());
        amsshipCargoTransferResult.setDeleteName(null);
        amsshipCargoTransferResult.setDeleteTime(null);
        amsshipCargoTransferResult.setInsertUsername("admin");
        amsshipCargoTransferResult.setUpdateTime(new Date());
        amsshipCargoTransferResult.setInsertUpdateRemark("无");
        amsshipCargoTransferResult.setUpdateUsername("admin");
        amsshipCargoTransferResult.setDeleted(new BigDecimal(0));
        return amsshipCargoTransferResultMapper.insert(amsshipCargoTransferResult);
    }

    @Override
    public int deleteByPrimaryKey(BigDecimal cargoTransferResultId) {
        return amsshipCargoTransferResultMapper.deleteByPrimaryKey(cargoTransferResultId);
    }

    @Override
    public int updateByPrimaryKey(BigDecimal cargoTransferResultId) {
        return amsshipCargoTransferResultMapper.updateByPrimaryKey(cargoTransferResultId);
    }

    @Override
    public BigDecimal selectMaxId() {
        return amsshipCargoTransferResultMapper.selectMaxId();
    }

    @Override
    public AmsshipCargoTransferResult selectByPrimaryKey(BigDecimal cargoTransferResultId) {
        return amsshipCargoTransferResultMapper.selectByPrimaryKey(cargoTransferResultId);
    }

    @Override
    public List<Map<String, Object>> getGroup() {
        return amsshipCargoTransferResultMapper.getGroup();
    }

    @Override
    public List<Map<String, Object>> getCargoId() {
        return amsshipCargoTransferResultMapper.getCargoId();
    }
    //删除
    @Override
    public int updateByPrimaryKeySelective(AmsshipCargoTransferResult amsshipCargoTransferResult) {
        return amsshipCargoTransferResultMapper.updateByPrimaryKeySelective(amsshipCargoTransferResult);
    }

    @Override
    public List<Map<String,Object>> selectByOrder(Integer cargoTransferResultId) {
        return amsshipCargoTransferResultMapper.selectByOrder(cargoTransferResultId);
    }

    @Override
    public List<Map<String, Object>> insertBetchId() {
        return amsshipCargoTransferResultMapper.insertBetchId();
    }



}
